Weak::PanamaHash< B > Class Template Reference

Panama hash. More...

`#include <panama.h>`

Inheritance diagram for Weak::PanamaHash< B >:

## Public Member Functions

unsigned int | DigestSize () const
| Provides the digest size of the hash.
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message.
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from AlgorithmImpl< IteratedHash< word32, NativeByteOrder, 32 >, PanamaHash< LittleEndian > >
std::string | AlgorithmName () const
| The algorithm name.
Public Member Functions inherited from IteratedHash< word32, NativeByteOrder, 32 >
unsigned int | BlockSize () const
| Provides the block size of the hash.
ByteOrder | GetByteOrder () const
| Provides the byte order of the hash.
void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)
| Adjusts the byte ordering of the hash.
Public Member Functions inherited from IteratedHashBase< word32, HashTransformation >
| IteratedHashBase ()
| Construct an IteratedHashBase.
unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
byte * | CreateUpdateSpace (size_t &size)
| Requests space which can be written into by the caller.
void | Restart ()
| Restart the hash.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Static Public Member Functions

static const char * | StaticAlgorithmName ()
Static Public Member Functions inherited from AlgorithmImpl< IteratedHash< word32, NativeByteOrder, 32 >, PanamaHash< LittleEndian > >
static std::string | StaticAlgorithmName ()
| The algorithm name.

## Static Public Attributes

static const int | DIGESTSIZE = 32
Static Public Attributes inherited from IteratedHash< word32, NativeByteOrder, 32 >
static const int | BLOCKSIZE

## Additional Inherited Members

Public Types inherited from IteratedHash< word32, NativeByteOrder, 32 >
typedef NativeByteOrder | ByteOrderClass
typedef word32 | HashWordType
Public Types inherited from IteratedHashBase< word32, HashTransformation >
typedef word32 | HashWordType

## Detailed Description

template<class B = LittleEndian>
class Weak::PanamaHash< B >

Panama hash.

See also
  Panama Hash

Definition at line 44 of file panama.h.

## Constructor & Destructor Documentation

## ~PanamaHash()

template<class B = LittleEndian>

virtual Weak::PanamaHash< B >::~PanamaHash | ( |  | ) |

inline virtual

Definition at line 48 of file panama.h.

## PanamaHash()

template<class B = LittleEndian>

Weak::PanamaHash< B >::PanamaHash | ( |  | ) |

inline

Definition at line 49 of file panama.h.

## Member Function Documentation

## DigestSize()

template<class B = LittleEndian>

unsigned int Weak::PanamaHash< B >::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 50 of file panama.h.

## TruncatedFinal()

template<class B = LittleEndian>

void PanamaHash::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize )

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Reimplemented from IteratedHashBase< word32, HashTransformation >.

Definition at line 440 of file panama.cpp.

## StaticAlgorithmName()

template<class B = LittleEndian>

const char * Weak::PanamaHash< B >::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 52 of file panama.h.

## AlgorithmProvider()

template<class B = LittleEndian>

std::string Weak::PanamaHash< B >::AlgorithmProvider | ( |  | ) | const

inline virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Note
  Provider is not universally implemented yet.

Reimplemented from IteratedHashBase< word32, HashTransformation >.

Definition at line 53 of file panama.h.

## Member Data Documentation

## DIGESTSIZE

template<class B = LittleEndian>

const int Weak::PanamaHash< B >::DIGESTSIZE = 32

static

Definition at line 47 of file panama.h.

The documentation for this class was generated from the following files:

- panama.h
- panama.cpp